package scripts;

import com.sun.star.beans.PropertyValue;
import com.sun.star.document.XDocumentInsertable;
import com.sun.star.frame.XController;
import com.sun.star.frame.XModel;
import com.sun.star.io.IOException;
import com.sun.star.lang.IllegalArgumentException;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.script.provider.XScriptContext;
import com.sun.star.text.XTextCursor;
import com.sun.star.text.XTextDocument;
import com.sun.star.text.XTextViewCursor;
import com.sun.star.text.XTextViewCursorSupplier;
import com.sun.star.ui.dialogs.XFilePicker;
import com.sun.star.uno.Exception;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

public class Test {
	
	public static void InsertDocumentTest(XScriptContext xScriptContext) {
		String sURL = "";
		try {
			sURL = getFilePathToInsert(xScriptContext.getComponentContext());
		} catch (Exception e1) {
			e1.printStackTrace();
		}
		if (sURL.isEmpty())
			return;
		PropertyValue[] args = new PropertyValue[1];
		args[0] = new PropertyValue();
		args[0].Name = "FilterName";
		args[0].Value = "HTML (StarWriter)";
		
		XModel xModel = xScriptContext.getDocument();
		XController xController = xModel.getCurrentController();
		
		XTextViewCursorSupplier xTextViewCursorSupplier = UnoRuntime.queryInterface(
			XTextViewCursorSupplier.class, xController);
		XTextViewCursor xTextViewCursor = xTextViewCursorSupplier.getViewCursor();
		
		XTextDocument xTextDoc = UnoRuntime.queryInterface(XTextDocument.class, xModel);
		XTextCursor xTextCursor = xTextDoc.getText().createTextCursorByRange(
				UnoRuntime.queryInterface(XTextCursor.class, xTextViewCursor));
		XDocumentInsertable xDocInsert = UnoRuntime.queryInterface(XDocumentInsertable.class, xTextCursor);
		try {
			xDocInsert.insertDocumentFromURL(sURL, args);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static String getFilePathToInsert(XComponentContext xContext) throws Exception {
		XMultiComponentFactory xMcf = xContext.getServiceManager();
		Object fp = xMcf.createInstanceWithContext("com.sun.star.ui.dialogs.FilePicker", xContext);
		XFilePicker xFilePicker = UnoRuntime.queryInterface(XFilePicker.class, fp);
		int n = xFilePicker.execute();
		if (n == 1) {
			return xFilePicker.getFiles()[0];
		}
		return "";
	}
	
	
	public static void main(String[] args) {
	}
}
